import java.io.*;
import java.util.ArrayList;
import javax.swing.*;


public class WireTest {
    ArrayList<Wire> wlist = new ArrayList<Wire>();


 public void read(File file)
     {
	String delims = "[\\s]+";		
	try (BufferedReader br = new BufferedReader(new FileReader(file));) 
	{
	   String CurrentLine;

	   while ((CurrentLine = br.readLine()) != null) 
	   {
		// debug: System.out.println(CurrentLine);
		//Split each line of text file
 		String[] tokens = (CurrentLine.trim().split(delims));
		if (tokens[0].equals("W")) {
			Wire w = new Wire(tokens);
			wlist.add(w);
		}
	   }
	   br.close(); 
      } 		
      catch (IOException e) {
	   JOptionPane.showMessageDialog(null, e);
	   System.err.println(e);
      }
    }

   static public void main(String[] args) {
	String filename = args.length>0? args[0]: "circuit1w.txt";
	int n = args.length>1? Integer.parseInt(args[1]): 0;
	File file = new File(filename);
	WireTest app = new WireTest();
	app.read(file);

	int count=0;
	for (Wire w: app.wlist) {
		count++;
		System.out.println("\nWire " + count);
		System.out.println(w);
		double x = w.bounds.getX();
		double y  = w.bounds.getY();
		double wd = w.bounds.getWidth();
		double ht = w.bounds.getHeight();
		System.out.format("bounding box (%g %g) size (%g %g)%n",x,y,wd,ht);
	}

   }
}
	

   